#|

 14-Dec-1999  Dialog to make multiple shared copies automatically.  
              The new shared parts are being created, but not moved
              to new location.
              Fixed location problem.  Program is working.

 15-Dec-1999  Uses original part name as part of copy name.
            

|#

;; Last modified  : 15-Dec-1999
;; Category       : Parts
;; Author         : Bruce Fisher (bfisher@lhcarbide.com)
;; Company        : L.H. Carbide Corporation
;; Macro Purpose  : Create multiple shared copies
;; Filename       : multi_cp_a.lsp
;; SD Revision	: 7.11,7.51
;; Macro Revision	: 1.10
;; Platform       : Windows NT 4.0
;; Video Mode        :  Native
;; Monitor Resolution:  1280x1024

(in-package :LHC)
(use-package :OLI)

(sd-defdialog 'mult_cpy
  :dialog-title "Multi Copy"
  :variables
  '((POINT_LIST)
    (CP_PART
            :value-type :part-incl-new
            :modifies :contents
            :title "Prt to Copy"
	      :prompt-text "Identify part to copy." 
    )
    (A_WP   
            :value-type :wp 
	      :title "Workplane"
	      :prompt-text "Identify workplane." 
    )
    (A_ASM   
            :value-type :assembly 
	      :modifies :contents 
	      :title "Assembly"
	      :prompt-text "Select Assembly."
    )

    (INC_NUM   
            :value-type :integer
            :toggle-type :invisible
	      :initial-value 0
    )

    (NEW_PRT_NM
            :initial-value "New_copy"
    )     

    (NM_ADD)

    (O_PRT)

    (PNT_1  
            :value-type :point-3d-pick
            :title "Source Loc."
            :prompt-text "Select reference location."
    )
    (PNT_2  
            :value-type :point-3d-pick
            :title "Target Loc."
            :prompt-text "Pick a point or press Back"
            :after-input (progn
              (push-point pnt_2)
              (sd-call-cmds (c_point pnt_2)))
    )

    (BACK :push-action (pop-point)))

  :local-functions
    '((PUSH-POINT (a-new-point)
         (push a-new-point point_list)
     )
      (POP-POINT ()
         (pop point_list)
         (unless point_list
           (sd-set-variable-status 'back :enable nil)))

      (MULTI-CP (pnt_1 pnt_2)
         (progn
         (setq inc_num (+ inc_num 1))
         (setq nm_add (sd-num-to-string inc_num))
         (setq new_prt_nm (concatenate 'string o_prt "." nm_add))
         (sd-call-cmds (create_multiple_pa 
                            :share
                            :source cp_part
                            :name new_prt_nm
                            :owner a_asm
                            :keep_attr :on
                            :translate :two_ptv pnt_1 pnt_2)
          ))
      ) 

       (MAIN-ACTION ()
         (progn
         (setq o_prt (sd-inq-obj-basename cp_part))
         (dolist (pnt_2 point_list)
         (multi-cp pnt_1 pnt_2)
          )
          )
    ))

;  :prompt-variable 'pnt_2
  :ok-action
     '(main-action))
